#include <iostream>
#include <asm/io.h>

#define BASEPORT 0x378 /* lp1 */
#define CHAN 0x1 /* Channel open/closed relay address */
#define DOOR 0x2 /* Open door relay address */

int door_state = 0;
int chan_state = 0;

void init_parallel();
void parallel_down();
void chan_relay(int state);
void door_relay(int state);

using namespace std;

int main(int argc, char *argv[]){
  cout << ":: pcfone v0.1 ::" << endl;
  cout << "Give access to parallel port ";
  init_parallel();
  cout << "Parallel port test           ";
  parallel_down(); 

  int running = 1;
  int choice = 0;

  while(running){
    cout << "Channel relay (1), Door relay (2), Exit (3): ";
    cin >> choice;
    
    if(choice == 1)
     {
       if(chan_state) 
         chan_state = 0;
       else
         chan_state = 1;

       chan_relay(chan_state);
     }
    else if(choice == 2)
     {
       if(door_state)
	 door_state = 0;
       else
         door_state = 1;

       door_relay(door_state);
     }
    else if(choice == 3)
      running = 0;

  }
  

  return 0;
}

void init_parallel(){
  if (ioperm(BASEPORT, 3, 1)) {perror("ioperm"); exit(1);}
  cout << "[OK]" << endl;
}

void parallel_down(){
  outb(0, BASEPORT);
  cout << "[OK]" << endl;
}

void chan_relay(int state){

  if(state){
    if(door_state)
      { outb((CHAN + DOOR) , BASEPORT); } 
      else 
      { outb(CHAN, BASEPORT); }

    cout << "Channel status: [open]" << endl;
  } else {
    if(door_state){
      outb(DOOR, BASEPORT); } else {
      outb(0, BASEPORT); }  
    cout << "Channel status: [closed]" << endl;
  }

}

void door_relay(int state){
 if(state){
    if(chan_state)
      { outb((CHAN + DOOR) , BASEPORT); } 
      else 
      { outb(DOOR, BASEPORT); }

    cout << "Door status: [open]" << endl;
  } else {
    if(chan_state){
      outb(CHAN, BASEPORT); } else {
      outb(0, BASEPORT); }  
    cout << "Door status: [closed]" << endl;
  }

}
